SystemOrganization addCategory: #'BP2010H1-CI-Srv'!

Object subclass: #ServerScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BP2010H1-CI-Srv'!

ServerScripts class
	instanceVariableNames: 'lastVersion'!

ServerScripts class
	instanceVariableNames: 'lastVersion'!

!ServerScripts class methodsFor: 'as yet unclassified' stamp: 'srv 1/3/2011 11:35'!
loadNewestMonticelloPackage
	| repoInspector index versionList |
	repoInspector := MCFileRepositoryInspector repository: self repository workingCopy: nil.
	repoInspector packageSelection: 0. "In order to get a list of _all_ version, no package should be preselected."
	versionList := repoInspector versionList.
	index := 1.
	[ (self packages anySatisfy: [ :each | (versionList at: index) asString beginsWith: each asString ])
		or: [ index >= repoInspector versionList size ] ] whileFalse: [ index := index + 1 ].
	repoInspector versionSelection: index.
	repoInspector explore.
	lastVersion == repoInspector version
		ifFalse: [ 
			lastVersion := repoInspector version.
			repoInspector load.
			Transcript
				cr;
				show: 'Neue Version geladen: ' , repoInspector version name.
			 ^ true ]
		ifTrue: [ 
			Transcript
				cr;
				show: 'Keine neue Version geladen'.
			^ false ]! !

!ServerScripts class methodsFor: 'as yet unclassified' stamp: 'srv 12/16/2010 18:52'!
packages

	 ^ #( Squeak2JS BP2010H1-CI-Srv ).! !

!ServerScripts class methodsFor: 'as yet unclassified' stamp: 'srv 12/15/2010 14:15'!
repository
	^ MCHttpRepository allInstances at: 27	"hirschfeld squeaksource"! !

!ServerScripts class methodsFor: 'as yet unclassified' stamp: 'srv 12/15/2010 15:17'!
runTests
	| suite |
	suite := TestSuite new.
	self testCases
		do: [:each | each isAbstract
				ifFalse: [each addToSuiteFromSelectors: suite]].
	suite name: 'S2J Test'.
	^ TestRunner new runSuite: suite; result! !

!ServerScripts class methodsFor: 'as yet unclassified' stamp: 'srv 12/16/2010 18:50'!
testCases
	^ {S2JParserTest.
	S2JPrinterTest.
	S2JSqueakAstToJsAstTest.
	S2JCodeFactoryTest }! !

Morph subclass: #TrafficLight
	instanceVariableNames: 'yellow green red'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BP2010H1-CI-Srv'!

!TrafficLight commentStamp: 'srv 12/15/2010 16:15' prior: 0!
"| tf |
tf := TrafficLight new.
10 timesRepeat: [
	tf switch.
	tf toggleAll.
	(Delay forSeconds: 1) wait
	]."!

!TrafficLight class methodsFor: 'configuration' stamp: 'srv 12/16/2010 18:05'!
colors

	 ^ #(red green yellow)! !

!TrafficLight class methodsFor: 'plugs' stamp: 'srv 12/15/2010 15:49'!
green

	 ^1! !

!TrafficLight class methodsFor: 'plugs' stamp: 'srv 12/15/2010 15:49'!
red

	 ^3! !

!TrafficLight class methodsFor: 'plugs' stamp: 'srv 12/15/2010 15:49'!
yellow

	 ^2! !

!TrafficLight methodsFor: 'as yet unclassified' stamp: 'srv 12/16/2010 18:27'!
buildMorphs
	| position |
	self openInWorld.
	self extent: 50 @ (50 * self class colors size).
	position := self center - (0 @ 50).
	self class colors
		do: [ :aColor | | morph |
			morph := self addMorph: (self colorMorphFor: aColor).
			morph center: position.
			Transcript cr;show: position.
			position := position + (0 @ 50) ]! !

!TrafficLight methodsFor: 'as yet unclassified' stamp: 'srv 12/16/2010 18:04'!
colorMorphFor: aColor

	| morph |
	morph := CircleMorph new.
	morph extent: 45@45.
	morph color: (Color perform: aColor).
	 ^morph! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/16/2010 18:49'!
computeColor: aTestRunnerResult.
	
	aTestRunnerResult hasErrors ifTrue: [  ^self onlyRed ].
	self red: false.
	aTestRunnerResult hasFailures ifTrue: [ ^self onlyYellow ].
	aTestRunnerResult unexpectedPasses size > 0 ifTrue: [ self yellow: true. ^self green: true. ].
	self onlyGreen.
! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/15/2010 15:58'!
green
	^ green! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/15/2010 15:58'!
green: anObject
	^ green := anObject! !

!TrafficLight methodsFor: 'as yet unclassified' stamp: 'srv 12/16/2010 18:48'!
initialize

	super initialize.
	yellow := red := green := false.
	self openInWorld.
	self runTests.
	self startStepping.
	"self buildMorphs."! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/16/2010 18:49'!
onlyGreen

	red := yellow := false.
	green := true.
	self color: Color green.
! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/16/2010 18:49'!
onlyRed

	yellow := green := false.
	red := true.
	
	self color: Color red.! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/16/2010 18:49'!
onlyYellow

	red := green := false.
	yellow := true.
	
	self color: Color yellow.
! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/15/2010 15:58'!
red
	^ red! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/15/2010 15:58'!
red: anObject
	^ red := anObject! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/16/2010 18:48'!
runTests
	| result |
	result := ServerScripts runTests.
	self computeColor: result.
	self switch! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/16/2010 18:48'!
step
	ServerScripts loadNewestMonticelloPackage
		ifTrue: [ self runTests ]! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/16/2010 18:50'!
stepTime

	 ^ 10000000! !

!TrafficLight methodsFor: 'as yet unclassified' stamp: 'srv 12/16/2010 18:53'!
switch
	| command |
	command := 'sispmctl '.
	#(#red #green #yellow )
		do: [:color | 
			(self perform: color)
				ifTrue: [command := command , '-o ']
				ifFalse: [command := command , '-f '].
			command := command
						, (self class perform: color) , ' '].
	CommandShell command: command, ';exit'! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/15/2010 16:12'!
toggleAll

	yellow := yellow not.
	green := green not.
	red := red not.! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/16/2010 17:57'!
toggleGreen
	
	self green: self green not.
	self switch.
	^ self green! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/16/2010 17:57'!
toggleRed
	
	self red: self red not.
	self switch.
	^ self red! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/16/2010 17:57'!
toggleYellow
	
	self yellow: self yellow not.
	self switch.
	^ self yellow! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/15/2010 15:58'!
yellow
	^ yellow! !

!TrafficLight methodsFor: 'accessing' stamp: 'srv 12/15/2010 15:58'!
yellow: anObject
	yellow := anObject! !
